SystemOrganization addCategory: #'Tweak-Books'!

CPanel subclass: #CBookWindow
	instanceVariableNames: ''
	classVariableNames: 'ControlButtons'
	poolDictionaries: ''
	category: 'Tweak-Books'!

CBookWindow defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="list" toSet="list:" changeEvent="listChanged">list</field>
	<field toGet="control" toSet="control:" changeEvent="controlChanged">control</field>
	<field toGet="book" toSet="book:" changeEvent="bookChanged">book</field>
	<field toGet="view" toSet="view:" changeEvent="viewChanged">view</field>
	<field toGet="nameField" toSet="nameField:" changeEvent="nameFieldChanged">nameField</field>
</fields>'!

!CBookWindow class methodsFor: 'class initialization' stamp: 'tak 5/15/2005 17:56'!
initialize
	Smalltalk
		at: #CProjectBuilder
		ifPresent: [:pb | pb registerOpenCommand: {'Book'. {CBook. #open}. 'Muti-page structures'}]! !

!CBookWindow methodsFor: 'actions' stamp: 'tak 5/15/2005 14:24'!
add
	player add.! !

!CBookWindow methodsFor: 'actions' stamp: 'tak 5/21/2005 18:26'!
animationView
	player view: #animation! !

!CBookWindow methodsFor: 'accessing' stamp: 'tak 5/15/2005 12:03'!
book
	"Answer the book of the receiver"
	<bewareOf: #bookChanged>
	^self propertyValueAt: #book! !

!CBookWindow methodsFor: 'accessing' stamp: 'tak 5/15/2005 12:03'!
book: aValue
	"Modify the receiver's book"
	^self propertyValueAt: #book put: aValue with: #bookChanged! !

!CBookWindow methodsFor: 'initialize' stamp: 'tak 5/21/2005 19:24'!
buttonSpec
	"#(label selector help)"
	^ {
		{(ScriptingSystem formAtKey: #TinyMenu). #showMenu. 'Show menu'}.
		#('-' remove 'Delete this page').
		#('L' prev 'Previous page').
		#('R' next 'Next page').
		#('+' add 'Add a new page after this one').
	}
! !

!CBookWindow methodsFor: 'actions' stamp: 'tak 5/16/2005 01:03'!
close
	super close.
	book close! !

!CBookWindow methodsFor: 'accessing' stamp: 'tak 5/15/2005 10:10'!
control
	"Answer the control of the receiver"
	<bewareOf: #controlChanged>
	^self propertyValueAt: #control! !

!CBookWindow methodsFor: 'accessing' stamp: 'tak 5/15/2005 10:10'!
control: aValue
	"Modify the receiver's control"
	^self propertyValueAt: #control put: aValue with: #controlChanged! !

!CBookWindow methodsFor: 'initialize' stamp: 'tak 5/15/2005 23:01'!
defaultPlayer
	^ CBook! !

!CBookWindow methodsFor: 'initialize' stamp: 'tak 5/16/2005 00:06'!
initialize

	super initialize.
	self define: #list as: CList new.
	self define: #control as: CPlayer new.
	self define: #book as: CBookCostume new.
	self define: #nameField as: CInputField new.
	self updateAll.
! !

!CBookWindow methodsFor: 'accessing' stamp: 'tak 5/15/2005 10:10'!
list
	"Answer the list of the receiver"
	<bewareOf: #listChanged>
	^self propertyValueAt: #list! !

!CBookWindow methodsFor: 'accessing' stamp: 'tak 5/15/2005 10:10'!
list: aValue
	"Modify the receiver's list"
	^self propertyValueAt: #list put: aValue with: #listChanged! !

!CBookWindow methodsFor: 'initialize' stamp: 'ar 6/25/2005 22:45'!
makeControlButtons
	| aFrame button panel |

	panel := CPlayer new.

	self buttonSpec do: [ :spec |
		button := CScriptingButton new.
		button target: nil actionSelector: spec second.
"		self startScript: spec second when: {button. #fire}."
		button fillStyle: #none.
		spec first isString
			ifTrue: [button label: spec first.
				button font: (TextStyle named: #WindowFont) defaultFont]
			ifFalse: [button image: spec first].
		button extent: 20@20.
		button balloonHelp: spec third translated.
		panel add: button].

	nameField borderStyle: #simple.
	nameField extent: 60 @ 20.
	nameField color: Color transparent.
	panel add: nameField.

	panel fillStyle: #verticalGradient.
 	panel fillColors: CWidgetLibrary default menuColors.
	panel borderStyle: #none.

	panel extent: 160@25.
	panel layout: CTableLayout new.
	panel layout listDirection: #leftToRight. 
	panel hResizing: #spaceFill; vResizing: #spaceFill.
	panel layout listCentering: #center.
	panel layout cellInset: 4.
	panel layoutInset: 2.

	panel layoutFrame: (aFrame := CLayoutFrame new).
	aFrame leftOffset: 0; leftFraction: 0.0.
	aFrame topOffset: 0; topFraction: 0.0.
	aFrame rightOffset: 0; rightFraction: 1.0.
	aFrame bottomOffset: 25; bottomFraction: 0.
	^ panel.! !

!CBookWindow methodsFor: 'accessing' stamp: 'tak 5/15/2005 23:35'!
nameField
	"Answer the nameField of the receiver"
	<bewareOf: #nameFieldChanged>
	^self propertyValueAt: #nameField! !

!CBookWindow methodsFor: 'accessing' stamp: 'tak 5/15/2005 23:35'!
nameField: aValue
	"Modify the receiver's nameField"
	^self propertyValueAt: #nameField put: aValue with: #nameFieldChanged! !

!CBookWindow methodsFor: 'actions' stamp: 'tak 5/15/2005 14:14'!
next
	player next.! !

!CBookWindow methodsFor: 'events' stamp: 'tak 5/15/2005 15:24'!
onPlayerChanged
	<on: playerChanged>
	super onPlayerChanged.
	self updateAll! !

!CBookWindow methodsFor: 'actions' stamp: 'tak 5/15/2005 12:06'!
prev
	player prev.! !

!CBookWindow methodsFor: 'actions' stamp: 'tak 5/15/2005 14:24'!
remove
	player remove! !

!CBookWindow methodsFor: 'initialize' stamp: 'tak 5/21/2005 19:28'!
setupBookCostume
	| aFrame |
	book hResizing: #spaceFill; vResizing: #spaceFill.
	book hScrollable: false; vScrollable: nil.
	book color: Color transparent.
	book layout: CTableLayout new.
	book layoutFrame: (aFrame := CLayoutFrame new).
	aFrame leftOffset: 106; leftFraction: 0.
	aFrame topOffset: 25; topFraction: 0.0.
	aFrame rightOffset: 0; rightFraction: 1.0.
	aFrame bottomOffset: 0; bottomFraction: 1.0.
! !

!CBookWindow methodsFor: 'initialize' stamp: 'ar 6/25/2005 22:45'!
setupControlCostume
	control := self makeControlButtons.
	control elements do: [:each | (each isKindOf: CScriptingButton)
				ifTrue: [each target: player]]! !

!CBookWindow methodsFor: 'initialize' stamp: 'ar 5/26/2005 20:16'!
setupCostume
	super setupCostume.

	self extent: 400@300.
	self layout := CProportionalLayout new.
"	self layout hResizing: #rigid.
	self layout vResizing: #rigid."
	self label: 'Book'.

	self setupListCostume.
	self add: list.
	self setupBookCostume.
	self add: book.
	self decorate: elements color: self defaultWindowColor.

	self setupControlCostume.
	self add: control.
! !

!CBookWindow methodsFor: 'initialize' stamp: 'tak 5/21/2005 19:27'!
setupListCostume
	| aFrame |
	list costume: CBookListCostume.
	list hResizing: #spaceFill; vResizing: #spaceFill.
	list width: 120.
	list allowDeselect: false.
	list layoutFrame: (aFrame := CLayoutFrame new).
	list itemMaker: CProjectCostume.

	aFrame leftOffset: 0; leftFraction: 0.0.
	aFrame topOffset: 25; topFraction: 0.0.
	aFrame rightOffset: 106; rightFraction: 0.
	aFrame bottomOffset: 0; bottomFraction: 1.0.
! !

!CBookWindow methodsFor: 'initialize' stamp: 'auto 5/22/2005 20:00'!
setupSlideshowCostume
	super setupCostume.
	self setupControlCostume.
	self costume: control.
	self width: 300.
	self floating: true.
	self roundCorners: true.
	self layoutInset: 4.
	self
		color: (self color alpha: 0.5)! !

!CBookWindow methodsFor: 'actions' stamp: 'tak 5/21/2005 19:24'!
showMenu
	| menu item |
	menu := CMenu new.
	item := menu
				add: 'Animation view'
				target: self
				action: #animationView.
	item checked: player view = #animation.
	item := menu
				add: 'Window view'
				target: self
				action: #windowView.
	item checked: player view = #window.
	item := menu
				add: 'Slide show view'
				target: self
				action: #slideshowView.
	item checked: player view = #slideshow.
	menu open! !

!CBookWindow methodsFor: 'actions' stamp: 'tak 5/21/2005 18:26'!
slideshowView
	player view: #slideshow! !

!CBookWindow methodsFor: 'events' stamp: 'tak 5/16/2005 17:32'!
updateAll
	book player: player.
	player
		ifNil: [list items: CCollection new.
			nameField player: nil]
		ifNotNil: [list items: player items.
			list wrapCursor: true.
			nameField
				player: (player fieldNamed: #selectionName)]! !

!CBookWindow methodsFor: 'accessing' stamp: 'tak 5/15/2005 19:43'!
view
	"Answer the view of the receiver"
	<bewareOf: #viewChanged>
	^self propertyValueAt: #view ifAbsentPut: #window! !

!CBookWindow methodsFor: 'accessing' stamp: 'tak 5/15/2005 19:40'!
view: aValue
	"Modify the receiver's view"
	^self propertyValueAt: #view put: aValue with: #viewChanged! !

!CBookWindow methodsFor: 'actions' stamp: 'tak 5/21/2005 19:23'!
windowView
	player view: #window! !

CPlayer subclass: #CBookCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Books'!

!CBookCostume commentStamp: '<historical>' prior: 0!
I show one page on cursor of a CBook.!

CBookCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="playerItems" toSet="playerItems:" changeEvent="playerItemsChanged">playerItems</field>
	<field toGet="selectedPlayer" toSet="selectedPlayer:" changeEvent="selectedPlayerChanged">selectedPlayer</field>
</fields>'!

!CBookCostume methodsFor: 'accessing' stamp: 'tak 5/16/2005 16:09'!
book
	^ self! !

!CBookCostume methodsFor: 'initialize' stamp: 'tak 5/15/2005 00:38'!
defaultPlayer
	^CBook! !

!CBookCostume methodsFor: 'events' stamp: 'tak 5/18/2005 17:53'!
onCursorChanged
	<on: cursorChanged in: playerItems>
	self elements isEmpty
		ifFalse: [self elements first signal: #thumbnailChanged].
	self removeAll.
	(player notNil
			and: [player selection notNil])
		ifTrue: [self add: player selection]! !

!CBookCostume methodsFor: 'events' stamp: 'ar 5/28/2005 21:46'!
onDrop: aPlayer 
	| selection tfm |
	<on: dragDrop>
	aPlayer = self ifTrue: [^aPlayer signal: #dropReject].
	(self isIn: aPlayer) ifTrue: [^aPlayer signal: #dropReject].
	selection := self player selection.
	selection ifNil: [^aPlayer signal: #dropReject].
	"Get player in child frame"
	tfm := selection globalToLocal composedWithLocal: aPlayer localToGlobal.
	aPlayer transform: tfm.
	selection add: aPlayer.
	"And inform it about the drop"
	aPlayer signal: #dropAccept with: selection.
! !

!CBookCostume methodsFor: 'events' stamp: 'tak 5/16/2005 17:26'!
onItemsChangedInPlayer
	"There should be no need for subclasses to override this method;
	It merely ensures that changes in the player are propagated accordingly."
	<on: itemsChanged in: player>
	playerItems := player
		ifNil: [nil]
		ifNotNil: [player items]! !

!CBookCostume methodsFor: 'events' stamp: 'ar 5/22/2005 18:08'!
onMouseDown
	| draggee |
	<on: mouseDown>
	self player selection ifNil: [^self].
	self player view = #small ifTrue: [^self].
	draggee := self player selection findDraggablePlayerAt: self cursorPoint.
	draggee notNil
		ifTrue: [^ draggee onDrag].
! !

!CBookCostume methodsFor: 'events' stamp: 'tak 5/15/2005 16:45'!
onPlayerChanged
	<on: playerChanged>
	"My player has changed, update the items"
	super onPlayerChanged.
	self onItemsChangedInPlayer.
	self onCursorChanged.! !

!CBookCostume methodsFor: 'accessing' stamp: 'tak 5/15/2005 00:53'!
playerItems
	"Answer the playerItems of the receiver"
	<bewareOf: #playerItemsChanged>
	^self propertyValueAt: #playerItems! !

!CBookCostume methodsFor: 'accessing' stamp: 'tak 5/15/2005 00:53'!
playerItems: aValue
	"Modify the receiver's playerItems"
	^self propertyValueAt: #playerItems put: aValue with: #playerItemsChanged! !

!CBookCostume methodsFor: 'accessing' stamp: 'tak 5/15/2005 09:08'!
selectedPlayer
	"Answer the selectedPlayer of the receiver"
	<bewareOf: #selectedPlayerChanged>
	^self propertyValueAt: #selectedPlayer! !

!CBookCostume methodsFor: 'accessing' stamp: 'tak 5/15/2005 09:08'!
selectedPlayer: aValue
	"Modify the receiver's selectedPlayer"
	^self propertyValueAt: #selectedPlayer put: aValue with: #selectedPlayerChanged! !

!CBookCostume methodsFor: 'initialize' stamp: 'auto 5/22/2005 19:52'!
setupAnimationCostume
	self stopScript: #onMouseDown.
	self layout: CTableLayout new.
	self layout hResizing: #shrinkWrap.
	self layout vResizing: #shrinkWrap.
	^ self! !

!CBookCostume methodsFor: 'accessing' stamp: 'tak 5/21/2005 18:28'!
view
	^ #animation! !

!CBookCostume methodsFor: 'accessing' stamp: 'tak 5/16/2005 11:53'!
view: aSymbol 
	^ #small! !

!CPlayer methodsFor: '*Tweak-Books' stamp: 'tak 5/17/2005 11:16'!
thumbnail
	^ self makeIcon! !

CPlayer subclass: #CTransfer
	instanceVariableNames: ''
	classVariableNames: 'CopyPlusIcon'
	poolDictionaries: ''
	category: 'Tweak-Books'!

!CTransfer commentStamp: 'tak 5/20/2005 00:47' prior: 0!
This is an under developed class which is inteded to be substitute of TransferMoprh.!

CTransfer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="passenger" toSet="passenger:" changeEvent="passengerChanged">passenger</field>
	<field toGet="source" toSet="source:" changeEvent="sourceChanged">source</field>
	<field toGet="passengerForm" toSet="passengerForm:" changeEvent="passengerFormChanged">passengerForm</field>
	<field toGet="shouldCopy" toSet="shouldCopy:" changeEvent="shouldCopyChanged">shouldCopy</field>
</fields>'!

!CTransfer class methodsFor: 'instance creation' stamp: 'tak 5/20/2005 00:48'!
withPassenger: anObject 
	| ddm |
	ddm := self new.
	ddm passenger: anObject.
"	ddm source: source.
	Sensor shiftPressed ifTrue: [ddm shouldCopy: true]."
	^ ddm! !

!CTransfer class methodsFor: 'instance creation' stamp: 'tak 5/20/2005 12:05'!
withPassenger: anObject from: source 
	| ddm |
	ddm := self new.
	ddm passenger: anObject.
	ddm source: source.
	Sensor shiftPressed ifTrue: [ddm shouldCopy: true].
	^ ddm! !

!CTransfer methodsFor: 'drawing' stamp: 'tak 6/8/2005 21:56'!
drawOn: aCanvas in: drawingBounds 
	aCanvas
		translucentImage: (self
				translucentImage: passengerForm
				alpha: 0.5
				depth: aCanvas depth)
		at: drawingBounds origin! !

!CTransfer methodsFor: 'initialization' stamp: 'tak 5/20/2005 17:20'!
initialize
	"initialize the state of the receiver"
	super initialize.
	self layout: CTableLayout new.
	self layout listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		layoutInset: 3;
		wrapCentering: #center;
		cellPositioning: #leftCenter.
	shouldCopy := false.
"	self on: #keyStroke send: #keyStroke: to: self"! !

!CTransfer methodsFor: 'event handling' stamp: 'tak 5/20/2005 19:48'!
onDropAccept
	<on: dropAccept>
	self close! !

!CTransfer methodsFor: 'event handling' stamp: 'tak 5/20/2005 19:39'!
onGeometryChanged
	<on: geometryChanged>
	"trickey way to avoid shadow"
	self costume removeHighlight: #dragMoveShadow.
	shouldCopy = self hand shiftPressed
		ifFalse: [shouldCopy := self hand shiftPressed.
			self updatePassengerForm]! !

!CTransfer methodsFor: 'event handling' stamp: 'tak 5/20/2005 17:18'!
onPassengerChanged
	<on: passengerChanged>
	self updatePassengerForm.
	self extent: passenger extent.! !

!CTransfer methodsFor: 'accessing' stamp: 'tak 5/19/2005 17:33'!
passenger
	"Answer the passenger of the receiver"
	<bewareOf: #passengerChanged>
	^self propertyValueAt: #passenger! !

!CTransfer methodsFor: 'accessing' stamp: 'tak 5/19/2005 17:33'!
passenger: aValue
	"Modify the receiver's passenger"
	^self propertyValueAt: #passenger put: aValue with: #passengerChanged! !

!CTransfer methodsFor: 'accessing' stamp: 'tak 5/20/2005 17:18'!
passengerForm
	"Answer the passengerForm of the receiver"
	<bewareOf: #passengerFormChanged>
	^ self
		propertyValueAt: #passengerForm
		ifAbsent: [^ self updatePassengerForm]! !

!CTransfer methodsFor: 'accessing' stamp: 'tak 5/19/2005 22:13'!
passengerForm: aValue
	"Modify the receiver's passengerForm"
	^self propertyValueAt: #passengerForm put: aValue with: #passengerFormChanged! !

!CTransfer methodsFor: 'initialization' stamp: 'tak 5/19/2005 19:49'!
setupCostume
	self userDraw := true.
! !

!CTransfer methodsFor: 'accessing' stamp: 'tak 5/20/2005 17:20'!
shouldCopy
	"Answer the shouldCopy of the receiver"
	<bewareOf: #shouldCopyChanged>
	^self propertyValueAt: #shouldCopy! !

!CTransfer methodsFor: 'accessing' stamp: 'tak 5/20/2005 17:20'!
shouldCopy: aValue
	"Modify the receiver's shouldCopy"
	^self propertyValueAt: #shouldCopy put: aValue with: #shouldCopyChanged! !

!CTransfer methodsFor: 'accessing' stamp: 'tak 5/20/2005 16:48'!
source
	"Answer the source of the receiver"
	<bewareOf: #sourceChanged>
	^self propertyValueAt: #source! !

!CTransfer methodsFor: 'accessing' stamp: 'tak 5/20/2005 16:48'!
source: aValue
	"Modify the receiver's source"
	^self propertyValueAt: #source put: aValue with: #sourceChanged! !

!CTransfer methodsFor: 'drawing' stamp: 'tak 6/9/2005 15:05'!
translucentImage: aForm alpha: alpha depth: depth
	"Generate a better image depend on the display depth.
	I don't sure why this method is needed, I didn't find out how to draw
	a translucent image regardless of display depth..."
	| backGround mask |
	backGround := Form extent: aForm extent depth: aForm depth.
	depth = 32
		ifTrue: [aForm
				copyBits: backGround
				at: 0 @ 0
				translucent: alpha]
		ifFalse: [mask := (Form extent: aForm extent depth: 1)
						fillColor: (Color gray: alpha).
			(BitBlt current toForm: aForm)
				copyForm: mask
				to: 0 @ 0
				rule: Form and
				colorMap: (Bitmap with: 16rFFFFFFFF with: 0)].
	^ aForm! !

!CTransfer methodsFor: 'drawing' stamp: 'ar 6/25/2005 22:48'!
updatePassengerForm
	| form icon |
	form := passenger asPrimCostume asFormOfDepth: 32.
	shouldCopy ifTrue: [
		icon := CIconLibrary default at: #CopyPlusIcon.
		form getCanvas translucentImage: icon at: passengerForm extent - CopyPlusIcon extent].
	^ passengerForm := form! !

CListCostume subclass: #CBookListCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Books'!

!CBookListCostume commentStamp: 'tak 5/20/2005 11:30' prior: 0!
This is a costume to sohw the list of pages for CBook.
You can asocciate the elements by drag and drop.
I think I should merge these function into CListCostume itself,
but now this is just a experimental implementation.!

CBookListCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="spacer" toSet="spacer:" changeEvent="spacerChanged">spacer</field>
</fields>'!

!CBookListCostume methodsFor: 'drag and drop' stamp: 'tak 5/20/2005 19:12'!
dropItem: newItem at: newIndex from: oldList 
	| dummy oldIndex |
	oldIndex := oldList indexOf: newItem.
	dummy := CPlayer new.
	oldIndex > 0 ifTrue: [oldList at: oldIndex put: dummy].
	newItem close.
	player add: newItem at: newIndex.
	oldList remove: dummy.
	player cursor: newIndex.! !

!CBookListCostume methodsFor: 'initialize' stamp: 'tak 5/20/2005 11:40'!
initialize
	super initialize.
	self define: #spacer as: CPlayer new! !

!CBookListCostume methodsFor: 'drag and drop' stamp: 'tak 5/21/2005 17:01'!
onDragDropContents: dragContents 
	| newItem |
	dragContents shouldCopy
		ifTrue: [newItem := dragContents passenger player veryDeepCopy.
			newItem
				name: (CBook
						chooseNewName: newItem name
						except: (self player
								collect: [:each | each name]))]
		ifFalse: [newItem := dragContents passenger player].
	self
		dropItem: newItem
		at: (scrollTarget elements indexOf: spacer)
		from: dragContents source! !

!CBookListCostume methodsFor: 'drag and drop' stamp: 'auto 6/3/2005 16:44'!
onDragEnter
	| evt dragContents |
	<on: dragEnter in: scrollTarget>
	dragContents := (self hand dragContents ifNil:[^self]) asPlayer.
	dragContents == self player ifTrue:[^self]. "spurious enter"
	dragContents class = CTransfer ifFalse: [^self].

	evt := self runRrackDropZones.

	evt selector == #dragDrop
		ifTrue:[
			self onDragDropContents: dragContents.
			dragContents signal: #dropAccept with: self player]
		ifFalse: [dragContents signal: #dropReject with: self player].
	Processor activeProject
		forEach: #tick
		do: [spacer extent > (10 @ 10)
			ifTrue: [spacer extent: spacer extent - (10 @ 10)]
			ifFalse: [^ spacer close]]
! !

!CBookListCostume methodsFor: 'events' stamp: 'tak 5/20/2005 12:06'!
onMouseDragOnList
	| selected transfer |
	<on: mouseDrag>
	selected := scrollTarget findPlayerAt: scrollTarget cursorPoint.
	selected ifNil:[^self].
	transfer := CTransfer withPassenger: selected from: self player.
	transfer openInHand.
! !

!CBookListCostume methodsFor: 'drag and drop' stamp: 'tak 5/21/2005 16:53'!
runRrackDropZones
	| evt |
	self startTicking: #trackDropZones at: 100.
	evt := self waitUntilAnyOf: {
		scrollTarget. #dragLeave.
		scrollTarget. #dragDrop.
	}.
	self stopScript: #trackDropZones.
	^ evt
! !

!CBookListCostume methodsFor: 'accessing' stamp: 'tak 5/20/2005 16:47'!
spacer
	"Answer the spacer of the receiver"
	<bewareOf: #spacerChanged>
	^self propertyValueAt: #spacer! !

!CBookListCostume methodsFor: 'accessing' stamp: 'tak 5/20/2005 16:47'!
spacer: aValue
	"Modify the receiver's spacer"
	^self propertyValueAt: #spacer put: aValue with: #spacerChanged! !

!CBookListCostume methodsFor: 'drag and drop' stamp: 'tak 5/21/2005 00:41'!
trackDropZones
	| refPt lastIndex index |
	lastIndex := scrollTarget elements indexOf: spacer.
	refPt := scrollTarget cursorPoint.
	"figure out the guy above the cursor point so we know  
	what the reference y for resizing the spacers is"
	index := scrollTarget elements
				findFirstIndex: [:any | any ~~ spacer
						and: [any center y > refPt y]].
	"Easy way for animation"
	spacer
		extent: (index - 1 = lastIndex
				ifTrue: [spacer extent + (10 @ 10) min: 50 @ 50]
				ifFalse: [10 @ 10]).
	index = 0
		ifTrue: [scrollTarget addLast: spacer]
		ifFalse: [scrollTarget add: spacer at: index]! !

CSymbolType subclass: #CBookViewType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Books'!

CBookViewType defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CBookViewType class methodsFor: 'accessing' stamp: 'tak 5/21/2005 18:27'!
enumValues
	^#(animation window slideshow)! !

CList subclass: #CBook
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Books'!

!CBook commentStamp: 'tak 5/18/2005 01:00' prior: 0!
I am a book like player. You can choose my costume in 3 types with 'view' tile in the viewer.

small - no decoration, useful for animation.
window - for editing
full - for presentation
!

CBook defineFields: '<?xml  version="1.0" ?>
<fields>
	<field virtual="true" serializable="false" toGet="view" toSet="view:">view</field>
	<field virtual="true" serializable="false" toGet="selectionName" toSet="selectionName:">selectionName</field>
</fields>'!

!CBook class methodsFor: 'instance creation' stamp: 'tak 5/18/2005 18:07'!
buildNewPage
	| page |
	page := CPlayer new.
	page hResizing: #spaceFill;
		 vResizing: #spaceFill.
"	page color: Color blue lighter lighter."
	^ page! !

!CBook class methodsFor: 'instance creation' stamp: 'tak 5/21/2005 17:10'!
chooseNewName: example except: aCollection 
	"Choose initial name
	I think it is better to merge similar methods."
	"self chooseNewName: 'page' except: #('page1' 'page2')"
	| index newName stemAndNumericSuffix |
	stemAndNumericSuffix := example stemAndNumericSuffix.
	index := stemAndNumericSuffix last.
	[index := index + 1.
	newName := stemAndNumericSuffix first , index.
	aCollection includes: newName] whileTrue.
	^ newName! !

!CBook class methodsFor: 'instance creation' stamp: 'tak 5/16/2005 16:42'!
newWindow
	| book |
	book := self new.
	book costume: CBookWindow.
	^ book! !

!CBook class methodsFor: 'instance creation' stamp: 'tak 5/16/2005 16:43'!
open
	| book |
	book := self newWindow.
	book add: self startPage.
	book cursor: 1.
	^ book open! !

!CBook class methodsFor: 'constants' stamp: 'ar 6/24/2005 21:06'!
startPage
	| page item |
	page := self buildNewPage.
	page name: 'page1'.
	item := CPlayer new.
	item topLeft: 100 @ 50.
	item graphic: self startPageIcon.
	item extent: item graphic extent.
	page add: item.
	^ page! !

!CBook class methodsFor: 'constants' stamp: 'tak 5/20/2005 23:32'!
startPageIcon
	^ (Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAAGQAAAB2CAMAAAAJIsb2AAAAA3NCSVQICAjb4U/gAAAAwFBM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' base64Decoded asByteArray readStream)! !

!CBook methodsFor: 'actions' stamp: 'tak 5/19/2005 16:52'!
add
	"Add new page after cursor"
	| newPage |
	newPage := self class buildNewPage.
	newPage
		name: (self class
				chooseNewName: 'page'
				except: (self
						collect: [:each | each name])).
	self add: newPage at: self cursor + 1.
	self selection: newPage! !

!CBook methodsFor: 'accessing' stamp: 'tak 5/18/2005 12:24'!
cursor: aValue 
	^ super
		cursor: (wrapCursor
				ifTrue: [aValue - 1 \\ self size + 1]
				ifFalse: [aValue])! !

!CBook methodsFor: 'initialize' stamp: 'tak 5/15/2005 00:40'!
defaultCostume
	^ CBookCostume! !

!CBook methodsFor: 'scripting' stamp: 'tak 5/18/2005 16:54'!
initScriptors
	"This is an experiment code of script example"
	| scriptor lhv assign scriptBuilder |
	scriptBuilder := [:selector :operator | 
			scriptor := CScriptorTile new.
			scriptor receiver: self.
			scriptor selector: selector.
			lhv := CPropertyTile new receiver: self;
						 property: #cursor;
						 valueType: CNumberType;
						 yourself.
			assign := lhv asAssignmentTile.
			assign operator: operator.
			assign expression expression value: 1.
			scriptor statements add: assign].
	scriptBuilder value: #next value: #+.
	scriptBuilder value: #prev value: #-! !

!CBook methodsFor: 'initialize' stamp: 'tak 5/18/2005 12:10'!
initialize
	super initialize.
	self wrapCursor: true.
! !

!CBook methodsFor: 'events' stamp: 'tak 5/16/2005 00:24'!
onCursorChanged: newCursor 
	super onCursorChanged: newCursor.
	self signal: #selectionNameChanged! !

!CBook methodsFor: 'costume' stamp: 'ar 5/26/2005 19:25'!
openSlideshowCostume
	| oldCostume newCostume base pos |
	oldCostume := self costume.
	newCostume := CBookWindow new.
	self costume: newCostume.
	newCostume setupSlideshowCostume.
	oldCostume container
		ifNotNil: [self open.
			base := oldCostume world.
			self world addFirst: newCostume book.
			newCostume book bounds: base localBounds].
	pos := CWindowManager default altCollapsePositionFor: self.
	self bottomLeft: pos.
	oldCostume close.
	oldCostume player: nil.
	self waitTick! !

!CBook methodsFor: 'costume' stamp: 'auto 5/22/2005 20:05'!
openSmallCostume
	| oldCostume newCostume |
	oldCostume := self costume.
	newCostume := CBookCostume new.
	self costume: newCostume.
	newCostume setupAnimationCostume.
	oldCostume container
		ifNotNil: [self open.
			newCostume globalPosition: oldCostume book globalPosition.
"			oldCostume costume costume animateBoundsFrom: oldCostume bounds to: newCostume bounds"].
	oldCostume close.
	oldCostume player: nil.
	self waitTick! !

!CBook methodsFor: 'costume' stamp: 'tak 5/16/2005 17:24'!
openWindowCostume
	| oldCostume newCostume |
	oldCostume := self costume.
	newCostume := CBookWindow new.
	self costume: newCostume.
	oldCostume container
		ifNotNil: [self open.
			newCostume globalPosition: oldCostume book globalPosition.
			newCostume costume costume animateBoundsFrom: oldCostume bounds to: newCostume bounds].
	oldCostume close.
	oldCostume player: nil.
	self waitTick! !

!CBook methodsFor: 'actions' stamp: 'tak 5/19/2005 16:33'!
remove
	| oldCursor |
	self removeAt: (oldCursor := self cursor).
	self cursor: oldCursor.! !

!CBook methodsFor: 'scripting' stamp: 'tak 5/18/2005 16:45'!
scriptsWithClassDo: aBlock 
	super scriptors isEmpty
		ifTrue: [self initScriptors].
	super scriptsWithClassDo: aBlock! !

!CBook methodsFor: 'accessing' stamp: 'tak 5/15/2005 23:41'!
selectionName
	^ self selection
		ifNotNil: [self selection name]! !

!CBook methodsFor: 'accessing' stamp: 'tak 5/15/2005 23:41'!
selectionName: aValue 
	self selection
		ifNotNil: [self selection name: aValue].
	^ aValue! !

!CBook methodsFor: 'actions' stamp: 'auto 5/22/2005 18:51'!
showMenu
	"Show menu. (This method shold be in costume, although)"
	| menu item |
	menu := CMenu new.
	item := menu
				add: 'Animation view'
				target: self costume
				action: #animationView.
	item checked: view = #animation.
	item := menu
				add: 'Window view'
				target: self costume
				action: #windowView.
	item checked: view = #window.
	item := menu
				add: 'Slide show view'
				target: self costume
				action: #slideshowView.
	item checked: view = #slideshow.
	menu open! !

!CBook methodsFor: 'accessing' stamp: 'tak 5/15/2005 14:57'!
view
	^ costume view! !

!CBook methodsFor: 'accessing' stamp: 'tak 5/21/2005 19:42'!
view: aSymbol 
	aSymbol = self view
		ifTrue: [self].
	aSymbol = #animation
		ifTrue: [self openSmallCostume].
	aSymbol = #window
		ifTrue: [self openWindowCostume].
	aSymbol = #slideshow
		ifTrue: [self openSlideshowCostume].
	costume view: aSymbol.
	self signal: #viewChanged.
	^ aSymbol! !

!CBook methodsFor: 'tiles' stamp: 'tak 5/16/2005 23:56'!
viewerSpecAdditions
	^ '
	<category name="book" type="CBook">
		<slot selector="cursor" type="CNumberType"/>
		<message selector="next"/>
		<message selector="prev"/>
		<slot selector="view" type="CBookViewType"/>
	</category>
'! !

CButton subclass: #CScriptingButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Books'!

!CScriptingButton commentStamp: 'tak 5/22/2005 15:27' prior: 0!
I am another interesting experimantal class.
An instance of me privide etoys script in a textual code.
User can learn how I work just looking at the viewer.
!

CScriptingButton defineFields: '<?xml  version="1.0" ?>
<fields>
	<field type="CPlayerType" toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
</fields>'!

!CScriptingButton methodsFor: 'accessing' stamp: 'tak 5/22/2005 15:28'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!CScriptingButton methodsFor: 'accessing' stamp: 'tak 5/22/2005 15:28'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

!CScriptingButton methodsFor: 'initialize' stamp: 'auto 5/22/2005 18:45'!
target: anObject actionSelector: selector 
	| script |
	target := anObject.
	script := 'onFire
	<on: fire>
	target {1}' format: {selector asString}.
	self compileScript: script! !
CBookWindow initialize!
